#include <iostream>
#include <algorithm>

using namespace std;

int main()
{
    int t;
    scanf("%d", &t);
    int n, k;
    scanf("%d %d", &n, &k);
    int l[n];
    for (int i=0; i<n; i++) scanf("%d", &l[i]);
    sort(l, l+n);

    // sim
    int a=0;
    for (auto el : l) {
        if (a > el) a--;
        else a++;
    }

    int l2[n], j=0;
    int razlika = a-k;

    for (int i=razlika; i<n; i++)
        l2[j++] = l[i];
    for (int i=0; i<razlika; i++)
        l2[j++] = l[i];

    a=0;
    for (auto el : l) {
        if (a > el) a--;
        else a++;
    }

    if (a != k) printf("NE");
    else {
        printf("DA\n");
        if (t) {
            for (auto el : l2) {
                printf("%d ", el);
            }
        }
    }

    return 0;
}